/*************************************************************************/
/*                                                                       */
/*                  Language Technologies Institute                      */
/*                     Carnegie Mellon University                        */
/*                        Copyright (c) 2007                             */
/*                        All Rights Reserved.                           */
/*                                                                       */
/*  Permission is hereby granted, free of charge, to use and distribute  */
/*  this software and its documentation without restriction, including   */
/*  without limitation the rights to use, copy, modify, merge, publish,  */
/*  distribute, sublicense, and/or sell copies of this work, and to      */
/*  permit persons to whom this work is furnished to do so, subject to   */
/*  the following conditions:                                            */
/*   1. The code must retain the above copyright notice, this list of    */
/*      conditions and the following disclaimer.                         */
/*   2. Any modifications must be clearly marked as such.                */
/*   3. Original authors' names are not deleted.                         */
/*   4. The authors' names are not used to endorse or promote products   */
/*      derived from this software without specific prior written        */
/*      permission.                                                      */
/*                                                                       */
/*  CARNEGIE MELLON UNIVERSITY AND THE CONTRIBUTORS TO THIS WORK         */
/*  DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING      */
/*  ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT   */
/*  SHALL CARNEGIE MELLON UNIVERSITY NOR THE CONTRIBUTORS BE LIABLE      */
/*  FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES    */
/*  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN   */
/*  AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,          */
/*  ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF       */
/*  THIS SOFTWARE.                                                       */
/*                                                                       */
/*************************************************************************/
/*             Author:  Alan W Black (awb@cs.cmu.edu)                    */
/*               Date:  January 2007                                     */
/*************************************************************************/
/*                                                                       */
/*  libstring test                                                       */
/*                                                                       */
/*************************************************************************/
#include <stdio.h>

#define FSL_TEST 1
#include "string.h"

int main(int argc, char **argv)
{
    char *string1 = "four";
    char string2[12];

    printf("strlen\n");
    printf("  strlen(NULL) %d\n",strlen(NULL)); /* fails in real strlen */
    printf("  strlen(\"\") %d\n",strlen(""));
    printf("  strlen(\"four\") %d\n",strlen(string1));
    printf("strcpy\n");
    printf("  strcpy(string2,\"four\") >%s<\n",strcpy(string2,"four"));
    printf("  strcpy(string2,\"\") >%s<\n",strcpy(string2,""));
    printf("strncpy\n");
    printf("  strncpy(string2,\"four\",2) >%s<\n",strncpy(string2,"four",2));
    printf("mems\n");
    memcpy(string2,"qpr",1);
    printf("  memcpy(string2,\"qpr\",1) >%s<\n",string2);
    strcpy(string2,"four");
    memmove(string2,"rwp",2);
    printf("  memmove(string2,\"rwp\",2) >%s<\n",string2);
    memset(string2,'a',3);
    printf("  memset(string2,'a',3) >%s<\n",string2);
    printf("  memcmp(string2,\"bbb\",3) %d\n",memcmp(string2,"bbb",3));
    printf("  memcmp(string2,\"aaan\",4) %d\n",memcmp(string2,"aaan",4));
    printf("  memcmp(string2,\"aaan\",3) %d\n",memcmp(string2,"aaan",3));
    printf("strcmp\n");
    printf("  strcmp(\"hello\",\"hello\") %d\n",strcmp("hello","hello"));
    printf("  strcmp(\"aaar\",string2) %d\n",strcmp("aaar",string2));
    printf("  strcmp(\"hello\",\"hell\") %d\n",strcmp("hello","hell"));
    printf("  strcmp(\"hello\",\"bye\") %d\n",strcmp("hello","bye"));
    printf("  strcmp(\"hello\",\"bye\") %d\n",strcmp("hello","bye"));
    printf("  strcmp(\"hello\",\"help\") %d\n",strcmp("hello","help"));
    printf("  strcmp(\"hello\",\"hela\") %d\n",strcmp("hello","hela"));
    printf("  strcmp(\"hello\",\"\") %d\n",strcmp("hello",""));
    printf("  strcmp(\"\",\"\") %d\n",strcmp("",""));
    printf("  strcmp(\"\",NULL) %d\n",strcmp("",NULL));
    printf("  strcmp(NULL,\"\") %d\n",strcmp(NULL,""));
    printf("  strncmp(\"aaar\",string2,4) %d\n",strncmp("aaar",string2,4));
    printf("  strncmp(\"aaan\",string2,4) %d\n",strncmp("aaan",string2,4));
    printf("  strncmp(\"aaan\",string2,3) %d\n",strncmp("aaan",string2,3));
    printf("  strncmp(\"aaan\",string2,2) %d\n",strncmp("aaan",string2,2));
    printf("  strncmp(\"aaan\",string2,1) %d\n",strncmp("aaan",string2,1));
    printf("  strncmp(\"aaan\",string2,0) %d\n",strncmp("aaan",string2,0));
    printf("  strncmp(\"bbbn\",string2,0) %d\n",strncmp("aaan",string2,0));
    printf("str index\n");
    printf("  strchr(\"abcde\",'a') >%s<\n",strchr("abcde",'a'));
    printf("  strchr(\"abcde\",'c') >%s<\n",strchr("abcde",'c'));
    printf("  strchr(\"abcde\",'q') >%s<\n",strchr("abcde",'q'));
    printf("  strchr(\"abcaa\",'c') >%s<\n",strchr("abcaa",'c'));
    printf("  strchr(\"abcbb\",'b') >%s<\n",strchr("abcbb",'b'));
    printf("  strrchr(\"abcbb\",'b') >%s<\n",strrchr("abcbb",'b'));
    printf("  strrchr(\"abcbb\",'q') >%s<\n",strrchr("abcbb",'q'));
    printf("  strrchr(\"abcbb\",'c') >%s<\n",strrchr("abcbb",'c'));
    printf("  strstr(\"needle\",\"ed\") >%s<\n",strstr("needle","ed"));
    printf("  strstr(\"needle\",\"edle\") >%s<\n",strstr("needle","edle"));
    printf("  strstr(\"needle\",\"edled\") >%s<\n",strstr("needle","edled"));
    printf("  strstr(\"needle\",\"ted\") >%s<\n",strstr("needle","ted"));

    return 0;
}
